# cython: language_level=3

cimport numpy as np
import cython

@cython.boundscheck(False)
@cython.cdivision(True) # Don't check for divide-by-zero.
def pasteminbleps(np.uint32_t ampsize, np.ndarray[np.float32_t] py_outp, np.ndarray[np.int32_t] py_naivex2outxp, np.uint32_t outsize, np.ndarray[np.float32_t] py_demultiplexedp, np.ndarray[np.int32_t] py_naivex2offp, np.ndarray[np.float32_t] py_ampp, np.uint32_t naivex, np.uint32_t naiverate, np.uint32_t outrate, np.uint32_t mixinsize):
    cdef np.float32_t* outp = &py_outp[0]
    cdef np.int32_t* naivex2outxp = &py_naivex2outxp[0]
    cdef np.float32_t* demultiplexedp = &py_demultiplexedp[0]
    cdef np.int32_t* naivex2offp = &py_naivex2offp[0]
    cdef np.float32_t* ampp = &py_ampp[0]
    cdef np.uint32_t out0
    cdef np.float32_t dclevel
    cdef np.uint32_t dcindex
    cdef np.uint32_t ampchunk
    cdef np.float32_t a
    cdef np.uint32_t i
    cdef np.float32_t* mixinp
    cdef np.uint32_t dccount
    # TODO LATER: This code needs tests.
    out0 = naivex2outxp[naivex]
    dclevel = 0
    dcindex = 0
    while ampsize:
        ampchunk = min(ampsize, naiverate - naivex)
        for naivex in range(naivex, naivex + ampchunk):
            a = ampp[0]
            ampp += 1
            if a:
                i = naivex2outxp[naivex] - out0
                mixinp = demultiplexedp + naivex2offp[naivex]
                if dcindex <= i: # We can DC-adjust while pasting this mixin.
                    dccount = i - dcindex
                    if dccount & 0x1:
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x2:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x4:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x8:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x10:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x20:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x40:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    while dccount >= 0x80:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        dccount -= 0x80
                    if mixinsize & 0x1:
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x2:
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x4:
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x8:
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x10:
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x20:
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x40:
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                    while mixinsize >= 0x80:
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a + dclevel
                        outp += 1
                        mixinp += 1
                        mixinsize -= 0x80
                else: # The mixin starts before the pending DC adjustment.
                    dccount = i + mixinsize - dcindex
                    if dccount & 0x1:
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x2:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x4:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x8:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x10:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x20:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    if dccount & 0x40:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                    while dccount >= 0x80:
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        outp[0] += dclevel
                        outp += 1
                        dccount -= 0x80
                    outp -= mixinsize
                    if mixinsize & 0x1:
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x2:
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x4:
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x8:
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x10:
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x20:
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                    if mixinsize & 0x40:
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                    while mixinsize >= 0x80:
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        outp[0] += mixinp[0] * a
                        outp += 1
                        mixinp += 1
                        mixinsize -= 0x80
                dcindex = i + mixinsize
                dclevel += a
        ampsize -= ampchunk
        naivex = 0
        out0 -= outrate
    dccount = outsize - dcindex
    if dccount & 0x1:
        outp[0] += dclevel
        outp += 1
    if dccount & 0x2:
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
    if dccount & 0x4:
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
    if dccount & 0x8:
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
    if dccount & 0x10:
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
    if dccount & 0x20:
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
    if dccount & 0x40:
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
    while dccount >= 0x80:
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        outp[0] += dclevel
        outp += 1
        dccount -= 0x80
